import java.util.ArrayList;

public abstract class Card {
    protected String name;
    private int score;
    public static final String set = "\u001B[0m";
    public static final String green = "\u001B[32m";
    public static final String red = "\u001B[31m";
    public static final String yellow = "\u001B[33m";
    public static final String blue = "\u001B[34m";


    public Card() {
    }

    public Card(int score) {
        this.score = score;
    }

    public int getScore() {
        return score;
    }

    public void setScore(int score) {
        this.score = score;
    }


    public abstract String toString();

    public abstract void print();

    public abstract void act(User chosenUser, int numOfChosenCard ,ArrayList<User> users, ArrayList<Card> remainingCards, Card upperCard);

    public boolean isAvailableToPut(int numOfChosenCard, User chosenUser, Card upperCard) {
        if (chosenUser.getUserCards().get(numOfChosenCard) instanceof ColoredCard) {
            ColoredCard chosenColoredCard = (ColoredCard) chosenUser.getUserCards().get(numOfChosenCard);
            if (chosenColoredCard.isAvailableToPutAColoredCard(numOfChosenCard, chosenUser, upperCard))
                return true;
            else
                return false;
        } else {
            WildCard chosenWildCard = (WildCard) chosenUser.getUserCards().get(numOfChosenCard);
            if (chosenWildCard.isAvailableToPutAWildCard(numOfChosenCard, chosenUser, upperCard))
                return true;
            else
                return false;
        }

    }
}
