public abstract class ColoredCard extends Card {
    private String color;

    /**
     * create a Colored card that according to subClasses create a special kind of colored cards
     *
     * @param color
     * @param score
     */
    public ColoredCard(String color, int score) {
        super(score);
        setScore(score);
        setColor(color);
    }

    /**
     * get the color of card
     *
     * @return
     */
    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }


    @Override
    public String toString() {
        String s = "|$$$$$$$$$$$$$$$|\n";
        s += "|               |\n";
        s += name + "\n";
        s += "|               |\n";
        s += "|$$$$$$$$$$$$$$$|\n";
        return s;
    }

    @Override
    public void print() {
        String first = null;
        if (color.equals("red")) {
            first = red;
        } else if (color.equals("yellow")) {
            first = yellow;
        } else if (color.equals("blue")) {
            first = blue;
        } else if (color.equals("green")) {
            first = green;
        }
        System.out.println(first + toString() + set);
    }

    public boolean isAvailableToPutAColoredCard(int numOfChosenCard, User chosenUser, Card upperCard) {
        ColoredCard chosen = (ColoredCard) chosenUser.getUserCards().get(numOfChosenCard);
        if (upperCard instanceof ColoredCard) {
            ColoredCard upper = (ColoredCard) upperCard;
            if (chosen instanceof NumericalCard && upper instanceof NumericalCard) {
                NumericalCard chosenNum = (NumericalCard) chosen;
                NumericalCard upperNum = (NumericalCard) upper;
                if (upper.getColor().equals(chosen.getColor()) || upperNum.getNumber() == chosenNum.getNumber()) {
                    return true;
                } else {
                    return false;
                }
            } else {
                if (chosen.getColor().equals(upper.getColor())) {
                    return true;
                } else {
                    return false;
                }
            }
        }
        else {
            WildCard upper = (WildCard) upperCard;
            if (upper.getNextColor().equals(chosen.getColor()))
                return true;
            else
                return false;
        }
    }
}
